/***********************************************************************
     PPD Custamaize Tool
         Version 1.02 (2013/05/29)
***********************************************************************/

#include <stdio.h>
#include <string.h>

enum {
	MODE_ADD = 0,		// ǉ
	MODE_REPLACE,		// u
};

FILE *g_infp = 0;		// PPDt@C
FILE *g_outfp = 0;		// oPPDt@C
FILE *g_parafp = 0;		// p[^ t@C

char	g_szPathName[3][1024];
int		g_nMode;

int		Initialize( char* argv[] );
void	Uninitialize();
int		CheckInputPPD();
int		Add( int argc, char* argv[] );
int		Replace( int argc, char* argv[] );
char	*StrReplace( char *String, const char *From, const char *To );
char	*StrShift( char *String, size_t nShift );
void	StrTrim( char *String );

int main(int argc, char* argv[])
{
	int i;

	// p[^ `FbN
	if(argc < 4)
	{
		for(i = strlen(argv[0]) ; i >= 0 ; i--)
		{
			if(argv[0][i] == '\\')
				break;
		}
		printf("usage:  %s [/R] 1 2 3 4 [5...]\n", &argv[0][i+1]);
		printf("  /R \t\tLine Replace Mode\n");
		printf("  1 \t\tinput ppd file name\n");
		printf("  2 \t\toutput ppd file name\n");
		printf("  3 \t\tparamerter file name\n");
		printf("  4 5... \tparamerter\n");
		return 0;
	}

	// 
	if(Initialize(argv) == 0)
	{
		Uninitialize();
		return 0;
	}

	if(g_nMode == MODE_ADD)
	{
		// PPDt@Cɒǉ镶񂪓Ăꍇ́AȂ
		if(CheckInputPPD() == 0)
		{
			Uninitialize();
			return 0;
		}

		// ǉ
		if(Add(argc, argv) == 0)
		{
			Uninitialize();
			return 0;
		}
	}
	else if(g_nMode == MODE_REPLACE)
	{
		// u
		if(Replace(argc, argv) == 0)
		{
			Uninitialize();
			return 0;
		}
	}

	// I
	Uninitialize();

	printf("Output : %s\n", g_szPathName[1]);

	return 0;
}

//*********************************************************
// 
//*********************************************************
int Initialize(char* argv[])
{
	int i, n;

	// [h
	g_nMode = MODE_ADD;
	n = 1;
	if(strcmp(argv[1], "/R") == 0)
	{
		g_nMode = MODE_REPLACE;
		++n;
	}

	for(i = 0 ; i < 3 ; i++)
	{
		strcpy(g_szPathName[i], argv[n+i]);
	}

	g_infp  = fopen(g_szPathName[0], "rb");
	g_outfp = fopen(g_szPathName[1], "wb");
	g_parafp = fopen(g_szPathName[2], "rb");

	if(g_infp == 0 || g_outfp == 0 || g_parafp == 0)
	{
		// PPD
		if(g_infp == 0)
		{
			printf("[ERROR] %s is not found.\n", g_szPathName[0]);
		}

		// oPPD
		if(g_outfp == 0)
		{
			printf("[ERROR] %s don't created.\n", g_szPathName[1]);
		}

		// p[^ t@C
		if(g_parafp == 0)
		{
			printf("[ERROR] %s is not found.\n", g_szPathName[2]);
		}
		return 0;
	}

	return 1;
}

//*********************************************************
// I
//*********************************************************
void Uninitialize()
{
	if(g_infp != 0)
	{
		fclose(g_infp);
		g_infp = 0;
	}
	if(g_outfp != 0)
	{
		fclose(g_outfp);
		g_outfp = 0;
	}
	if(g_parafp != 0)
	{
		fclose(g_parafp);
		g_parafp = 0;
	}
}

//*********************************************************
// p[^t@C1sڂPPDɋLqĂ邩ǂ
// `FbNB
// ɋLqĂꍇ0ALqĂȂ1ԂB
//*********************************************************
int CheckInputPPD()
{
	char szData[5120];
	char szFindStr[5120];
	char szCompData[5120];
	char szCompFindStr[5120];

	// p[^t@C1sڂǂݍށB
	if(fgets(szFindStr, sizeof(szFindStr), g_parafp) == 0)
	{
		printf("[ERROR] %s can not read.\n", g_szPathName[2]);
		return 0;
	}

	// PPD`FbN
	while(1)
	{
		if(fgets(szData, sizeof(szData), g_infp) == 0)
		{
			break;
		}

		// rp̈ɃRs[
		strcpy(szCompData, szData);
		strcpy(szCompFindStr, szFindStr);
		// rpɉsR[h폜
		StrTrim(szCompData);
		StrTrim(szCompFindStr);

		if(strcmp(szData, szFindStr) == 0)
		{
			printf("[ERROR] %s is already change.\n", g_szPathName[0]);
			return 0;
		}
	}

	// PPD擪ɖ߂B
	rewind(g_infp);

	return 1;
}

//*********************************************************
// PPDɃp[^t@C̏ǉ̂AoPPD
// ɏo͂܂B
//*********************************************************
int Add( int argc, char* argv[] )
{
	char szData[5120];
	char szFindStr[5120];
	char szParaData[5120];
	char szRep[16];
	int i;
	char szCompData[5120];
	char szCompFindStr[5120];

	// p[^PPD2sڂǂݍށB
	if(fgets(szFindStr, sizeof(szFindStr), g_parafp) == 0)
	{
		printf("[ERROR] %s can not read.\n", g_szPathName[2]);
		Uninitialize();
		return 0;
	}

	while(1)
	{
		// PPD1sǂݎ
		if(fgets(szData, sizeof(szData), g_infp) == 0)
		{
			// t@CŌ܂œǂݎB
			break;
		}

		// oPPDɃf[^݁B
		fputs(szData, g_outfp);

		// rp̈ɃRs[
		strcpy(szCompData, szData);
		strcpy(szCompFindStr, szFindStr);
		// rpɉsR[h폜
		StrTrim(szCompData);
		StrTrim(szCompFindStr);

		if(strcmp(szData, szFindStr) == 0)
		{
			// p[^t@C2sڂƓB

			// p[^t@C̓eoPPDɏށB
			while(1)
			{
				// p[^t@C1sǂݎ
				if(fgets(szParaData, sizeof(szParaData), g_parafp) == 0)
				{
					break;
				}

				// ̒us
				for(i = 4 ; i < argc; i++)
				{
					sprintf(szRep, "!%d!", i-4);
					StrReplace(szParaData, szRep, argv[i]);
				}

				// oPPDɃf[^݁B
				fputs(szParaData, g_outfp);
			}
			continue;
		}
	}

	return 1;
}

//*********************************************************
// PPDɃp[^t@C̏ǉ̂AoPPD
// ɏo͂܂B
//*********************************************************
int Replace( int argc, char* argv[] )
{
	char szData[5120];
	char szFindStr[5120];
	char szParaData[5120];
	char szRep[16];
	int i;
	int bReplace;
	char szCompData[5120];
	char szCompFindStr[5120];

	bReplace = 1;

	// p[^PPD1sڂǂݍށB
	if(fgets(szFindStr, sizeof(szFindStr), g_parafp) == 0)
	{
		printf("[ERROR] %s can not read.\n", g_szPathName[2]);
		Uninitialize();
		return 0;
	}

	while(1)
	{
		// PPD1sǂݎ
		if(fgets(szData, sizeof(szData), g_infp) == 0)
		{
			// t@CŌ܂œǂݎB
			break;
		}

		// rp̈ɃRs[
		strcpy(szCompData, szData);
		strcpy(szCompFindStr, szFindStr);
		// rpɉsR[h폜
		StrTrim(szCompData);
		StrTrim(szCompFindStr);

		if(strcmp(szCompData, szCompFindStr) == 0 && bReplace == 1)
		{
			// p[^t@C1sڂƓB

			// p[^t@C̓eoPPDɏށB
			// p[^t@C1sǂݎ
			if(fgets(szParaData, sizeof(szParaData), g_parafp) == 0)
			{
				// oPPDɃf[^݁B
				fputs(szData, g_outfp);
				bReplace = 0;
				continue;
			}

			// ̒us
			for(i = 5 ; i < argc; i++)
			{
				sprintf(szRep, "!%d!", i-5);
				StrReplace(szParaData, szRep, argv[i]);
			}

			// oPPDɃf[^݁B
			fputs(szParaData, g_outfp);

			// p[^PPD1sڂǂݍށB
			if(fgets(szFindStr, sizeof(szFindStr), g_parafp) == 0)
			{
				bReplace = 0;
			}
		}
		else
		{
			// oPPDɃf[^݁B
			fputs(szData, g_outfp);
		}
	}

	return 1;
}

//*********************************************************
//  String ̕ From 𕶎 To ŒuB
// u̕ String ̃TCY String ̋L̈𒴂ꍇ͖̓`B
//*********************************************************
char *StrReplace( char *String, const char *From, const char *To )
{
	int   nToLen;   // u镶̒
	int   nFromLen; // 镶̒
	int   nShift;
	char *start;    // Jnʒu
	char *stop;     //  String ̏I[
	char *p;

	nToLen   = strlen( To );
	nFromLen = strlen( From );
	nShift   = nToLen - nFromLen;
	start    = String;
	stop     = String + strlen( String );

	//  String ̐擪當 From 
	while( NULL != ( p = strstr( start, From ) ) )
	{
		//  To ʂł悤ɂ
		start = StrShift( p + nFromLen, nShift );
		stop  = stop + nShift;

		//  To 𕡎
		memmove( p, To, nToLen );
	}

	return String;
}//StrReplace

//*********************************************************
//  String  nShift ړB
// ړւ̃|C^ԂB
//*********************************************************
char *StrShift( char *String, size_t nShift )
{
	char *start = String;
	char *stop  = String + strlen( String );
	memmove( start + nShift, start, stop-start+1 );

	return String + nShift;
}//StrShift

//*********************************************************
//  String ̉sR[h폜B
//*********************************************************
void StrTrim( char *String )
{
	int i;
	int cnt = 0;

	if( String == NULL ) return;

	i = strlen( String ) - 1;
	// ̌sR[h(CR/LF)ȊO܂ŌJԂ
	while( i >= 0 && ( String[i] == '\r' || String[i] == '\n')) i--;
	// ŏIsR[hu
	if( i > 0 )	String[i+1] = '\0';
}

