#!/bin/bash

echo "=> Iniciamos la gestión de códigos para Canon ..."

# Primero generamos el PPD mediante el Cque.  De este se puede personalizar:
# *DefaultUserPassword: Custom.1234
# *DefaultUserID: Custom.1234
# *DefaultSecuredPassword: Custom.1234
## Que se corresponden con los parámetros enviados a la fotocopiadora:
# @PJL COMMENT CANPJL SET USERNAME = "7654321"
# @PJL COMMENT CANPJL SET USERID=1234
# @PJL COMMENT CANPJL SET USERPWD=1234
# @PJL COMMENT CANPJL SET SECUREPASSWD=1234
# @PJL ENTER LANGUAGE=PCL (el ppd que se instala/configura es el PCL, no el PXL [PXL==PCL6] o PS)

for PARAMETRO in "PJL COMMENT CANPJL SET USERNAME"; do
    if grep -a "${PARAMETRO}" "${TEADATAFILE}" &>/dev/null; then
        sed -i "0,/${PARAMETRO}/{s#${PARAMETRO}=.*#${PARAMETRO}=\"${NOMBREPRINT}\"#}" "${TEADATAFILE}"
    fi
done

for PARAMETRO in "PJL COMMENT CANPJL SET USERID"; do
    if grep -a "${PARAMETRO}" "${TEADATAFILE}" &>/dev/null; then
        sed -i "0,/${PARAMETRO}/{s#${PARAMETRO}=.*#${PARAMETRO}=${NOMBREPRINT}#}" "${TEADATAFILE}"
    fi
done

for PARAMETRO in "PJL COMMENT CANPJL SET USERPWD" \
"PJL COMMENT CANPJL SET SECUREPASSWD"; do
    if grep -a "${PARAMETRO}" "${TEADATAFILE}" &>/dev/null; then
        sed -i "0,/${PARAMETRO}/{s#${PARAMETRO}=.*#${PARAMETRO}=${USERCODEPRINT}#}" "${TEADATAFILE}"
    fi
done

# Para PPDs Postscript:
# %%BeginFeature: *CustomUserID True
# (9191)
# %%EndFeature
# } stopped cleartomark
# [{
# %%BeginFeature: *CustomUserPassword True
# (9191)
# %%EndFeature
# %%BeginFeature: *SecuredPassword None
if LINEA="$(grep -an "^%%BeginFeature: \*CustomUserID True" "${TEADATAFILE}")" &>/dev/null; then
    # LINEA="$(grep -an "^%%BeginFeature: \*CustomUserID True" "${TEADATAFILE}" | cut -d":" -f1)"
    LINEA="${LINEA//:*/}"
    ((LINEA++))
    sed -i "${LINEA}s/(.*)/(${NOMBREPRINT})/" "${TEADATAFILE}"
fi
if LINEA="$(grep -an "^%%BeginFeature: \*CustomUserPassword True" "${TEADATAFILE}")" &>/dev/null; then
    # LINEA="$(grep -an "^%%BeginFeature: \*CustomUserPassword True" "${TEADATAFILE}" | cut -d":" -f1)"
    LINEA="${LINEA//:*/}"
    ((LINEA++))
    sed -i "${LINEA}s/(.*)/(${USERCODEPRINT})/" "${TEADATAFILE}"
fi
if LINEA="$(grep -an "^%%BeginFeature: \*SecuredPassword True" "${TEADATAFILE}")" &>/dev/null; then
    # LINEA="$(grep -an "^%%BeginFeature: \*SecuredPassword True" "${TEADATAFILE}" | cut -d":" -f1)"
    LINEA="${LINEA//:*/}"
    ((LINEA++))
    sed -i "${LINEA}s/(.*)/(${USERCODEPRINT})/" "${TEADATAFILE}"
fi
# En el caso de usar buzón (PPD en formato PS, ya que los PXL tienen un bug), válido sólo si el UserID coincide con su número de buzón CustomMailbox:
# %%BeginFeature: *Mailbox None
# %% FoomaticRIPOptionSetting: Mailbox=None
# %%EndFeature
# %%BeginFeature: *CustomMailbox True
# (9292)
# %%EndFeature
if LINEA="$(grep -an "^%%BeginFeature: \*CustomMailbox True" "${TEADATAFILE}")" &>/dev/null; then
    # LINEA="$(grep -an "^%%BeginFeature: \*CustomMailbox True" "${TEADATAFILE}" | cut -d":" -f1)"
    LINEA="${LINEA//:*/}"
    ((LINEA++))
    sed -i "${LINEA}s/(.*)/(${NOMBREPRINT})/" "${TEADATAFILE}"
fi

# PPD de tipo PCL: Ejemplo Canon ImageRunner Advance 6555i (ppd del IES Sierra Palomera)
# En el caso de usar como destino el Buzón, y querer meter como código de buzón el código de usuario:
## Parámetros del PPD: Sección vía localhost:631 "Canon Device Specific"
# *DefaultDestination: Mailbox
# *DefaultMailbox: Custom.0
## Parámetros enviados a la fotocopiadora capturados por tea4cups:
# @PJL COMMENT CANPJL SET DEVICE=MAILBOX
# @PJL COMMENT CANPJL SET MAILBOXNUMBER=0
for PARAMETRO in "PJL COMMENT CANPJL SET MAILBOXNUMBER" ; do
    if grep -a "${PARAMETRO}" "${TEADATAFILE}" &>/dev/null; then
        sed -i "0,/${PARAMETRO}/{s#${PARAMETRO}=.*#${PARAMETRO}=${USERCODEPRINT}#}" "${TEADATAFILE}"
    fi
done

echo "=> Terminamos la gestión de códigos para Canon ..."
