#!/bin/bash

echo "=> Iniciamos la gestión de códigos para Ricoh ..."

# Para Ricoh PXL: PJL SET USERCODE
if grep -a "PJL SET USERCODE" "${TEADATAFILE}" &> /dev/null ; then
    sed -i "0,/PJL SET USERCODE/{s#PJL SET USERCODE=.*#PJL SET USERCODE=\"${USERCODEPRINT}\"#}" "${TEADATAFILE}"
fi
# Para personalizar la Password de Retención de copias: PASSRETENCION (Locked Printer)
# Comprobamos que PASSRETENCION no sea cero o null para adoptar su valor:
PASSRETENCION="$(crudini --get "${FICHCONFTEA4CUPS}" general PASSRETENCION 2> /dev/null)"
if [[ -z "${PASSRETENCION}" || "${PASSRETENCION}" == "0" || "${PASSRETENCION}" == "null" ]] ; then
    PASSRETENCION="${USERCODEPRINT}"
fi
JOBPASSWORD2="${PASSRETENCION}"
if grep -a "PJL SET JOBPASSWORD2" "${TEADATAFILE}" &> /dev/null ; then
    sed -i "s/^@PJL SET JOBPASSWORD2=.*/@PJL SET JOBPASSWORD2=\"${JOBPASSWORD2}\"/g" "${TEADATAFILE}"
fi
if grep -a "PJL SET USERID" "${TEADATAFILE}" &> /dev/null ; then
    # sed -i "0,/PJL SET USERID/{s#PJL SET USERID=.*#PJL SET USERID=\"${NOMBREPRINT}\"#}" "${TEADATAFILE}"
    sed -i "s/^@PJL SET USERID=.*/@PJL SET USERID=\"${NOMBREPRINT}\"/g" "${TEADATAFILE}"
fi
if grep -a "PJL SET OWNERID" "${TEADATAFILE}" &> /dev/null ; then
    # sed -i "0,/PJL SET USERID/{s#PJL SET USERID=.*#PJL SET USERID=\"${NOMBREPRINT}\"#}" "${TEADATAFILE}"
    sed -i "s/^@PJL SET OWNERID=.*/@PJL SET OWNERID=\"${NOMBREPRINT}\"/g" "${TEADATAFILE}"
fi
if grep -a "PJL SET HOSTLOGINNAME" "${TEADATAFILE}" &> /dev/null ; then
    # sed -i "0,/PJL SET HOSTLOGINNAME/{s#PJL SET HOSTLOGINNAME=.*#PJL SET HOSTLOGINNAME=\"${NOMBREPRINT}\"#}" "${TEADATAFILE}"
    sed -i "s/^@PJL SET HOSTLOGINNAME=.*/@PJL SET HOSTLOGINNAME=\"${NOMBREPRINT}\"/g" "${TEADATAFILE}"
fi

# Para Ricoh PS
if grep -a "^/usrcode(.*)def" "${TEADATAFILE}" &> /dev/null ; then
    #sed -i "s/9999/${USERCODEPRINT}/g" "${TEADATAFILE}"
    sed -i "0,/^\/usrcode/{s/^\/usrcode(.*)/\/usrcode(${USERCODEPRINT})/}" "${TEADATAFILE}"
    LINEA="$(grep -an "CustomUserCode" "${TEADATAFILE}" | cut -d":" -f1)"
    #LINEA="$(expr ${LINEA} + 1)"
    ((LINEA++))
    sed -i "${LINEA}s/(.*)/(${USERCODEPRINT})/" "${TEADATAFILE}"
fi

# Para Locked Printer con ID de usuario y código (p.e. Ricoh 4055 del CEIP Gaspar Remiro de Épila)
if grep -a "^/usrid(.*)def" "${TEADATAFILE}" &> /dev/null ; then
    #sed -i "s/9999/${USERCODEPRINT}/g" "${TEADATAFILE}"
    sed -i "0,/^\/usrid/{s/^\/usrid(.*)/\/usrid(${NOMBREPRINT})/}" "${TEADATAFILE}"
    LINEA="$(grep -an "CustomUserId" "${TEADATAFILE}" | cut -d":" -f1)"
    #LINEA="$(expr ${LINEA} + 1)"
    ((LINEA++))
    sed -i "${LINEA}s/(.*)/(${NOMBREPRINT})/" "${TEADATAFILE}"
fi

for PARAMETROS in "lppswd:CustomLockedPrintPassword:${PASSRETENCION}" \
"usrcode:CustomUserCode:${USERCODEPRINT}" ; do
    PARAMETRO1="${PARAMETROS%%:*}"
    PARAMETRO2="$(echo "${PARAMETROS}" | cut -d":" -f2)"
    VALORPARAM="${PARAMETROS//*:}"
    if grep -a "^/${PARAMETRO1}(.*)def" "${TEADATAFILE}" &> /dev/null ; then
        #sed -i "s/9999/${USERCODEPRINT}/g" "${TEADATAFILE}"
        sed -i "0,/^\/${PARAMETRO1}/{s/^\/${PARAMETRO1}(.*)/\/${PARAMETRO1}(${VALORPARAM})/}" "${TEADATAFILE}"
        LINEA="$(grep -an "${PARAMETRO2}" "${TEADATAFILE}" | cut -d":" -f1)"
        #LINEA="$(expr ${LINEA} + 1)"
        ((LINEA++))
        sed -i "${LINEA}s/(.*)/(${VALORPARAM})/" "${TEADATAFILE}"
    fi
done

# Para Locked Ricoh NX: Desbloqueo con tarjeta
LOCKEDRICOHNX="$(crudini --get "${FICHCONFTEA4CUPS}" general "LOCKEDRICOHNX" 2> /dev/null)"
FICHPARAMS_RICOH_LOCKED_NX="/usr/share/vitalinux/printers-tea4cups/ricoh-locked-NX"
if [[ -f "${FICHPARAMS_RICOH_LOCKED_NX}" ]] && (( ${LOCKEDRICOHNX} == 1 )) ; then
    OLDIFS=$IFS; IFS=$'\n'
    for LINEA in $(cat "${FICHPARAMS_RICOH_LOCKED_NX}") ; do
        PARAM=$(echo $LINEA | cut -d"=" -f1)
        # Elimina los espacios al comienzo - remove leading whitespace characters
        PARAM="${PARAM#"${PARAM%%[![:space:]]*}"}"
        # Elimina los espacios al final - remove trailing whitespace characters
        PARAM="${PARAM%"${PARAM##*[![:space:]]}"}"
        #echo $PARAM
        if ! grep -a "^${PARAM}" "${TEADATAFILE}" &> /dev/null ; then
            #VALOR="$(echo $LINEA | cut -d"=" -f2)"; echo $VALOR
            sed -i "6a${LINEA}" "${TEADATAFILE}"
        fi
    done
    IFS=$OLDIFS
fi

echo "=> Terminamos la gestión de códigos para Ricoh ..."