#!/bin/bash

echo "=> Preparamos el dialogo a mostrar al usuario: ${TEAPRINTERNAME} - ${TEAUSERNAME}"
FICHCONFTEA4CUPS="/etc/default/vx-dga-variables/vx-dga-l-tea4cups-print-codusers.conf"

# Rescatamos los valores del fichero de configuracion: DIRECTIVA:VALOR_DEFAULT
LISTA=(
    "TEXTNOMBREPRINT:Nombre de Usuario"
    "NOMBREPRINT:tunombre"
    "TEXTUSERCODEPRINT:Código de Impresión"
    "USERCODEPRINT:tucodigo"
    "MODO_PASS:0"
)
for VAR in "${LISTA[@]}" ; do
    DIRECTIVA="${VAR%:*}"
    VALOR_DEFAULT="${VAR#*:}"
    for SECCION in "${TEAPRINTERNAME}" "general" ; do
        USERCODEPRINT="$(crudini --get "${FICHCONFTEA4CUPS}" general USERCODEPRINT 2> /dev/null)"
    NOMBREPRINT="$(crudini --get "${FICHCONFTEA4CUPS}" general NOMBREPRINT 2> /dev/null)"
        MODO_PASS="$(crudini --get "${FICHCONFTEA4CUPS}" general MODO_PASS 2> /dev/null)"
    done
done
[[ -z "${MODO_PASS}" || ! ${MODO_PASS} =~ ^[[:digit:]]$ ]] && MODO_PASS="0"
# Comprobamos si hay que mostrar los input text asociados al nombre del usuario y código:
for DIRECTIVA in "SHOWNOMBREPRINT" "SHOWUSERCODEPRINT" ; do
    declare "${DIRECTIVA}"="$(crudini --get "${FICHCONFTEA4CUPS}" general "${DIRECTIVA}" 2> /dev/null)"
    [[ -z "${!DIRECTIVA}" || ! ${!DIRECTIVA} =~ ^[[:digit:]]$ ]] && \
    declare "${DIRECTIVA}"="1"
done
echo -e "=> Valores cargados de ${FICHCONFTEA4CUPS}:
    #NOMBREPRINT: ${NOMBREPRINT} \t #SHOWNOMBREPRINT: ${SHOWNOMBREPRINT}
    #USERCODEPRINT: ${USERCODEPRINT} \t #SHOWUSERCODEPRINT: ${SHOWUSERCODEPRINT}
    #MODO_PASS: ${MODO_PASS}"
# El TEXTO se personaliza mediante un sed desde vx-imprimir-con-usercode:
TEXTO="---"
VENTANA='yad --title "Gestión de Impresión en Vitalinux" --center --fixed '
VENTANA+='--window-icon "vitalinux" --image "impresora-multifuncion" '
VENTANA+='--text-align "center" --text "${TEXTO}" '
VENTANA+='--form '
(( ${SHOWNOMBREPRINT} == 1 )) && \
VENTANA+='--field="${TEXTNOMBREPRINT:-"Nombre de Usuario"}: " "${NOMBREPRINT:-profesor}" '
(( ${SHOWUSERCODEPRINT} == 1 )) && \
{
    (( ${MODO_PASS} == 0 )) && \
    VENTANA+='--field="${TEXTUSERCODEPRINT:-"Código de Impresión"}: " "${USERCODEPRINT:-0000}" ' || \
    VENTANA+='--field="${TEXTUSERCODEPRINT:-"Código de Impresión"}: ":H "${USERCODEPRINT:-0000}" '
}
VENTANA+='--button="Imprimir:0" --button="Cancelar:1"'
echo ${VENTANA}
RESPUESTA=$(eval ${VENTANA})
ESTADO=$?
echo "La respuesta y estado de salida son: \"${RESPUESTA}\" [${ESTADO}]"
echo "${ESTADO}" > /tmp/tea4cups-estado-${TEAUSERNAME}

if (( ${ESTADO} == 0 )) ; then
    if (( ${SHOWNOMBREPRINT} == 1 )) && (( ${SHOWUSERCODEPRINT} == 1 )) ; then
        NOMBRE="$(echo "${RESPUESTA}" | cut -d"|" -f1 | sed -e "s/ //g")"
        CODIGO="$(echo "${RESPUESTA}" | cut -d"|" -f2 | sed -e "s/ //g")"
    fi
    if (( ${SHOWNOMBREPRINT} != 1 )) && (( ${SHOWUSERCODEPRINT} == 1 )) ; then
        CODIGO="$(echo "${RESPUESTA}" | cut -d"|" -f1 | sed -e "s/ //g")"
        NOMBRE="${CODIGO}"
    fi
    if (( ${SHOWNOMBREPRINT} == 1 )) && (( ${SHOWUSERCODEPRINT} != 1 )) ; then
        NOMBRE="$(echo "${RESPUESTA}" | cut -d"|" -f1 | sed -e "s/ //g")"
        CODIGO="${NOMBRE}"
    fi
    echo "=> Los datos recogidos del dialogo son:
    NOMBRE: ${NOMBRE}
    CODIGO: ${CODIGO}"
    echo "${NOMBRE}" > /tmp/tea4cups-nombreprint-${TEAUSERNAME}
    echo "${CODIGO}" > /tmp/tea4cups-codusuario-${TEAUSERNAME}
fi